﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using DHTMLX.Common;

using System.Globalization;

namespace SchedulerNetAsp
{
    /// <summary>
    /// </summary>
    public class Save : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/xml";

            

            var action = new DataAction(context.Request.Form);

            var changedEvent = new Event();
            int ev_id = 0;
            int.TryParse(context.Request.Form["id"], out ev_id);

            changedEvent.id = ev_id;
            changedEvent.start_date = DateTime.Parse(context.Request.Form["start_date"], new CultureInfo("en-US"));
            changedEvent.end_date = DateTime.Parse(context.Request.Form["end_date"], new CultureInfo("en-US"));
            changedEvent.text = context.Request.Form["text"];

            var data = new SchedulerDataContext();

            try
            {
                switch (action.Type)
                {
                    case DataActionTypes.Insert: // define here your Insert logic
                        data.Events.InsertOnSubmit(changedEvent);
                        action.TargetId = changedEvent.id;
                        break;
                    case DataActionTypes.Delete: // define here your Delete logic
                        changedEvent = data.Events.SingleOrDefault(ev => ev.id == action.SourceId);
                        data.Events.DeleteOnSubmit(changedEvent);
                        break;
                    default:// "update" // define here your Update logic
                        var updated = data.Events.SingleOrDefault(ev => ev.id == action.SourceId);
                        updated.text = changedEvent.text;
                        updated.start_date = changedEvent.start_date;
                        updated.end_date = changedEvent.end_date;
                        break;
                }
                data.SubmitChanges();
            }
            catch (Exception a)
            {
                action.Type = DataActionTypes.Error;
            }

            context.Response.Write(new AjaxSaveResponse(action));
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}