﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using DHTMLX.Common;

using System.Globalization;

namespace SchedulerNetAsp
{
    /// <summary>
    /// </summary>
    public class SaveRecurring : IHttpHandler
    {


        protected bool deleteRelated(DataAction action, Recurring changedEvent, SchedulerDataContext context)
        {
            bool finished = false;
            if ((action.Type == DataActionTypes.Delete || action.Type == DataActionTypes.Update) && string.IsNullOrEmpty(changedEvent.rec_type))
            {
                context.Recurrings.DeleteAllOnSubmit(from ev in context.Recurrings where ev.event_pid == changedEvent.id select ev);
            }
            if (action.Type == DataActionTypes.Delete && changedEvent.event_pid != 0)
            {
                Recurring changed = (from ev in context.Recurrings where ev.id == action.TargetId select ev).Single();
                changed.rec_type = "none";
                finished = true;
            }
            return finished;
        }

        protected DataAction insertRelated(DataAction action, Recurring changedEvent, SchedulerDataContext context)
        {
            if (action.Type == DataActionTypes.Update)
            {//insert_related
                if (changedEvent.rec_type == "none")
                    action.Type = DataActionTypes.Delete;
            }
            return action;
        }
        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/xml";

            var changedEvent = new Recurring();

            int ev_id = 0;
            int.TryParse(context.Request.Form["id"], out ev_id);

            changedEvent.id = ev_id;
            changedEvent.start_date = DateTime.Parse(context.Request.Form["start_date"], new CultureInfo("en-US"));
            changedEvent.end_date = DateTime.Parse(context.Request.Form["end_date"], new CultureInfo("en-US"));
            changedEvent.text = context.Request.Form["text"];
            changedEvent.event_length = !string.IsNullOrEmpty(context.Request.Form["event_length"]) ? Convert.ToInt32(context.Request.Form["event_length"]) : 0;
            changedEvent.event_pid = !string.IsNullOrEmpty(context.Request.Form["event_pid"]) ? Convert.ToInt32(context.Request.Form["event_pid"]) : 0;
            changedEvent.rec_type = context.Request.Form["rec_type"];

            var action = new DataAction(context.Request.Form);

            var data = new SchedulerDataContext();

            try
            {
                bool isFinished = deleteRelated(action, changedEvent, data);
                if (!isFinished)
                {
                    switch (action.Type)
                    {
                        case DataActionTypes.Insert: // define here your Insert logic
                            data.Recurrings.InsertOnSubmit(changedEvent);
                            action.TargetId = changedEvent.id;
                            break;
                        case DataActionTypes.Delete: // define here your Delete logic
                            changedEvent = data.Recurrings.SingleOrDefault(ev => ev.id == action.SourceId);
                            data.Recurrings.DeleteOnSubmit(changedEvent);
                            break;
                        default:// "update" // define here your Update logic
                            var updated = data.Recurrings.SingleOrDefault(ev => ev.id == action.SourceId);
                            updated.text = changedEvent.text;
                            updated.start_date = changedEvent.start_date;
                            updated.end_date = changedEvent.end_date;
                            updated.event_length = changedEvent.event_length;
                            updated.event_pid = changedEvent.event_pid;
                            updated.rec_type = changedEvent.rec_type;

                            break;
                    }
                }
                data.SubmitChanges();
                action = insertRelated(action, changedEvent, data);
            }
            catch (Exception a)
            {
                action.Type = DataActionTypes.Error;
            }

            context.Response.Write(new AjaxSaveResponse(action));
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}